Index: /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm
===================================================================
--- /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34920)
+++ /main/trunk/greenstone2/perllib/cpan/Image/ExifTool/Canon.pm	(revision 34921)
@@ -2784,89 +3429,34 @@
         Name => 'FocusDistanceLower',
         %focusDistanceByteSwap,
-    },
-    0x57 => {
-        Name => 'FirmwareVersionLookAhead',
-        Hidden => 1,
-        # must look ahead to check location of FirmwareVersion string
-        Format => 'undef[0x1a6]',
-        RawConv => q{
-            my $t = substr($val, 0x1e8 - 0x57, 6);
-            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirmA} = 1;
-            $t = substr($val, 0x1ed - 0x57, 6);
-            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirmB} = 1;
-            return undef;   # not a real tag
-        },
-    },
-    0x77 => {
+        Hook => '$varSize += ($$self{CanonFirm} ? -1 : 0x10000) if $$self{CanonFirm} < 2',
+    },
+    0x78 => {
         Name => 'WhiteBalance',
-        Condition => '$$self{CanonFirmA}',
-        Notes => 'firmware 4.2.1',
         Format => 'int16u',
         SeparateTable => 1,
         PrintConv => \%canonWhiteBalance,
     },
-    0x78 => {
-        Name => 'WhiteBalance',
-        Condition => '$$self{CanonFirmB}',
-        Notes => 'firmware 1.0.4',
-        Format => 'int16u',
-        SeparateTable => 1,
-        PrintConv => \%canonWhiteBalance,
-    },
-    0x7b => {
-        Name => 'ColorTemperature',
-        Condition => '$$self{CanonFirmA}',
-        Format => 'int16u',
-    },
     0x7c => {
         Name => 'ColorTemperature',
-        Condition => '$$self{CanonFirmB}',
         Format => 'int16u',
     },
-    0x14e => {
+    0x14f => {
         Name => 'LensType',
-        Condition => '$$self{CanonFirmA}',
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0x14f => {
-        Name => 'LensType',
-        Condition => '$$self{CanonFirmB}',
-        Format => 'int16uRev', # value is big-endian
-        SeparateTable => 1,
-        PrintConv => \%canonLensTypes,
-    },
-    0x150 => {
-        %ciShortFocal,
-        Condition => '$$self{CanonFirmA}',
-    },
-    0x151 => {
-        %ciShortFocal,
-        Condition => '$$self{CanonFirmB}',
-    },
-    0x152 => {
-        %ciLongFocal,
-        Condition => '$$self{CanonFirmA}',
-    },
-    0x153 => {
-        %ciLongFocal,
-        Condition => '$$self{CanonFirmB}',
-    },
-    0x1e8 => { # firmware 4.2.1 (pre-production)
+    0x151 => { %ciMinFocal },
+    0x153 => { %ciMaxFocal,
+        Hook => '$varSize -= 4 if $$self{CanonFirm} < 2',
+    },
+    0x1ed => {
         Name => 'FirmwareVersion',
-        Condition => '$$self{CanonFirmA}',
         Format => 'string[6]',
         Writable => 0,
     },
-    0x1ed => { # firmware 1.0.4
-        Name => 'FirmwareVersion',
-        Condition => '$$self{CanonFirmB}',
-        Format => 'string[6]',
-        Writable => 0,
-    },
-    0x227 => { #(NC)
+    0x22c => { #(NC)
         Name => 'FileIndex',
-        Condition => '$$self{CanonFirmA}',
         Groups => { 2 => 'Image' },
         Format => 'int32u',
@@ -2874,7 +3464,109 @@
         ValueConvInv => '$val - 1',
     },
-    0x22c => { #(NC)
+    0x238 => { #(NC)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x368 => {
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
+    },
+);
+
+# Camera information for 1D X (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo1DX = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    DATAMEMBER => [ 0x00, 0x1b, 0x8e, 0x1ab ],
+    IS_SUBDIR => [ 0x3f4 ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        CameraInfo tags for the EOS 1D X.  Indices shown are for firmware version
+        1.0.2, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x28b]',
+        RawConv => q{
+            my $t = substr($val, 0x271, 6); # 1 = firmware 5.7.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x279, 6);    # 2 = firmware 6.5.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $t = substr($val, 0x280, 6);    # 3 = firmware 0.0.8/1.0.2/1.1.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 3, return undef;
+            $t = substr($val, 0x285, 6);    # 4 = firmware 2.1.0
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 4, return undef;
+            $self->Warn('Unrecognized CameraInfo1DX firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature,
+        Hook => '$varSize -= 3 if $$self{CanonFirm} < 3',
+    },
+    0x23 => { %ciFocalLength },
+    0x7d => {
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x8c => {
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x8e => {
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+        Hook => '$varSize -= 4 if $$self{CanonFirm} < 3; $varSize += 5 if $$self{CanonFirm} == 4',
+    },
+    0xbc => {
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0xc0 => {
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0xf4 => {
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0x1a7 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x1a9 => { %ciMinFocal },
+    0x1ab => { %ciMaxFocal,
+        # add another offset of -8 for firmware 5.7.1, and a large offset
+        # to effectively abort processing for unknown firmware
+        Hook => '$varSize += ($$self{CanonFirm} ? -8 : 0x10000) if $$self{CanonFirm} < 2',
+    },
+    0x280 => {
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+    },
+    0x2d0 => { # (doesn't seem to work for firmware 2.0.3 - PH)
         Name => 'FileIndex',
-        Condition => '$$self{CanonFirmB}',
         Groups => { 2 => 'Image' },
         Format => 'int32u',
@@ -2882,7 +3574,6 @@
         ValueConvInv => '$val - 1',
     },
-    0x233 => { #(NC)
+    0x2dc => { #(NC)
         Name => 'DirectoryIndex',
-        Condition => '$$self{CanonFirmA}',
         Groups => { 2 => 'Image' },
         Format => 'int32u',
@@ -2890,25 +3581,7 @@
         ValueConvInv => '$val + 1',
     },
-    0x238 => { #(NC)
-        Name => 'DirectoryIndex',
-        Condition => '$$self{CanonFirmB}',
-        Groups => { 2 => 'Image' },
-        Format => 'int32u',
-        ValueConv => '$val - 1',
-        ValueConvInv => '$val + 1',
-    },
-    0x363 => {
+    0x3f4 => {
         Name => 'PictureStyleInfo',
-        Condition => '$$self{CanonFirmA}',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
-    },
-    0x368 => {
-        Name => 'PictureStyleInfo',
-        Condition => '$$self{CanonFirmB}',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
     },
 );
@@ -2931,4 +3604,5 @@
         SeparateTable => 1,
         RawConv => '$val ? $val : undef', # don't use if value is zero
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
@@ -2948,21 +3622,23 @@
         Format => 'int16uRev',
         PrintConvColumns => 2,
-        PrintConv => { BITMASK => {
-            0 => 'Center',
-            1 => 'Top',
-            2 => 'Bottom',
-            3 => 'Upper-left',
-            4 => 'Upper-right',
-            5 => 'Lower-left',
-            6 => 'Lower-right',
-            7 => 'Left',
-            8 => 'Right',
-            9 => 'AI Servo1',
-           10 => 'AI Servo2',
-           11 => 'AI Servo3',
-           12 => 'AI Servo4',
-           13 => 'AI Servo5',
-           14 => 'AI Servo6',
-        } },
+        PrintConv => { 0 => '(none)',
+            BITMASK => {
+                0 => 'Center',
+                1 => 'Top',
+                2 => 'Bottom',
+                3 => 'Upper-left',
+                4 => 'Upper-right',
+                5 => 'Lower-left',
+                6 => 'Lower-right',
+                7 => 'Left',
+                8 => 'Right',
+                9 => 'AI Servo1',
+               10 => 'AI Servo2',
+               11 => 'AI Servo3',
+               12 => 'AI Servo4',
+               13 => 'AI Servo5',
+               14 => 'AI Servo6',
+           },
+        },
     },
     0x54 => { #15
@@ -2982,10 +3658,11 @@
         PrintConv => \%pictureStyles,
     },
-    0x93 => { %ciShortFocal }, #15
-    0x95 => { %ciLongFocal }, #15
+    0x93 => { %ciMinFocal }, #15
+    0x95 => { %ciMaxFocal }, #15
     0x97 => { #15
         Name => 'LensType',
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
@@ -2998,6 +3675,11 @@
         Format => 'string[16]',
     },
+    0xcc => { #PH (NC)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+    },
     0xd0 => {
-        Name => 'ImageNumber',
+        Name => 'FileIndex',
         Format => 'int16u',
         Groups => { 2 => 'Image' },
@@ -3094,6 +3776,5 @@
 );
 
-# Camera information for 5D Mark II (MakerNotes tag 0x0d)
-# (ref PH unless otherwise noted)
+# Camera information for 5D Mark II (MakerNotes tag 0x0d) (ref PH)
 %Image::ExifTool::Canon::CameraInfo5DmkII = (
     %binaryDataAttrs,
@@ -3101,7 +3782,26 @@
     FIRST_ENTRY => 0,
     PRIORITY => 0,
-    IS_SUBDIR => [ 0x15a, 0x17e ],
+    DATAMEMBER => [ 0x00, 0xea ],
+    IS_SUBDIR => [ 0x2f7 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'CameraInfo tags for the EOS 5D Mark II.',
+    NOTES => q{
+        CameraInfo tags for the EOS 5D Mark II.  Indices shown are for firmware
+        version 1.0.6, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x184]',
+        RawConv => q{
+            my $t = substr($val, 0x15a, 6); # 1 = firmware 3.4.6/3.6.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x17e, 6);    # 2 = firmware 4.1.1/1.0.6
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $self->Warn('Unrecognized CameraInfo5DmkII firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
     0x03 => { %ciFNumber },
     0x04 => { %ciExposureTime },
@@ -3109,5 +3809,5 @@
     0x07 => {
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x1b => { %ciMacroMagnification }, #PH
@@ -3179,35 +3879,13 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xe8 => { %ciShortFocal },
-    0xea => { %ciLongFocal },
-    0x15a => {
-        Name => 'CameraInfo5DmkII_2a',
-        Condition => '$$valPt =~ /^\d+\.\d+\.\d+[\s\0]/',
-        Notes => 'at this location for firmware 3.4.6 and 3.6.1',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CameraInfo5DmkII_2',
-        },
+    0xe8 => { %ciMinFocal },
+    0xea => { %ciMaxFocal,
+        # offset changes after this for different firmware versions
+        Hook => '$varSize += ($$self{CanonFirm} ? -36 : 0x10000) if $$self{CanonFirm} < 2',
     },
     0x17e => {
-        Name => 'CameraInfo5DmkII_2b',
-        Condition => '$$valPt =~ /^\d+\.\d+\.\d+[\s\0]/',
-        Notes => 'at this location for firmware 1.0.6 and 4.1.1',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CameraInfo5DmkII_2',
-        },
-    },
-);
-
-# variable-position Camera information for 5DmkII (ref PH)
-%Image::ExifTool::Canon::CameraInfo5DmkII_2 = (
-    %binaryDataAttrs,
-    FIRST_ENTRY => 0,
-    PRIORITY => 0,
-    IS_SUBDIR => [ 0x179 ],
-    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'More CameraInfo tags for the EOS 5D Mark II.',
-    0 => {
         Name => 'FirmwareVersion',
         Format => 'string[6]',
@@ -3216,5 +3894,5 @@
         RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
     },
-    0x3d => {
+    0x1bb => {
         Name => 'FileIndex',
         Groups => { 2 => 'Image' },
@@ -3223,5 +3901,5 @@
         ValueConvInv => '$val - 1',
     },
-    0x49 => { #(NC)
+    0x1c7 => { #(NC)
         Name => 'DirectoryIndex',
         Groups => { 2 => 'Image' },
@@ -3230,9 +3908,235 @@
         ValueConvInv => '$val + 1',
     },
-    0x179 => { #48
+    0x2f7 => { #48
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
+    },
+);
+
+# Camera information for 5D Mark III (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo5DmkIII = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    DATAMEMBER => [ 0x00, 0x1b, 0x23, 0x8e, 0x157 ],
+    IS_SUBDIR => [ 0x3b0 ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => q{
+        CameraInfo tags for the EOS 5D Mark III.  Indices shown are for firmware
+        versions 1.0.x, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x24d]',
+        RawConv => q{
+            my $t = substr($val, 0x22c, 6); # 1 = firmware 4.5.4/4.5.6
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x22d, 6);    # 2 = firmware 5.2.2/5.3.1/5.4.2
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $t = substr($val, 0x23c, 6);    # 3 = firmware 1.0.3/1.0.7
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 3, return undef;
+            $t = substr($val, 0x242, 6);    # 4 = firmware 1.2.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 4, return undef;
+            $t = substr($val, 0x247, 6);    # 5 = firmware 1.3.5
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 5, return undef;
+            $self->Warn('Unrecognized CameraInfo5DmkIII firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature,
+        # decrement $varSize for missing byte after this tag with firmware 5.x and earlier
+        # (and add large offset to effectively abort processing if unknown firmware)
+        Hook => '$varSize += ($$self{CanonFirm} ? -1 : 0x10000) if $$self{CanonFirm} < 3',
+    },
+    0x23 => { %ciFocalLength,
+        Hook => q{
+            $varSize -= 3 if $$self{CanonFirm} == 1;
+            $varSize -= 2 if $$self{CanonFirm} == 2;
+            $varSize += 6 if $$self{CanonFirm} >= 4;
+        },
+    },
+    0x7d => {
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x8c => {
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x8e => {
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+        Hook => q{
+            $varSize -= 4 if $$self{CanonFirm} < 3;
+            $varSize += 5 if $$self{CanonFirm} > 4;
+        },
+    },
+    0xbc => {
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0xc0 => {
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0xf4 => {
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0x153 => {
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x155 => { %ciMinFocal },
+    0x157 => { %ciMaxFocal,
+        Hook => '$varSize -= 8 if $$self{CanonFirm} < 3',
+    },
+    0x164 => {
+        Name => 'LensSerialNumber',
+        Format => 'undef[5]',
+        Priority => 0,
+        ValueConv => 'unpack("H*",$val)',
+        ValueConvInv => 'length($val) < 10 and $val = 0 x (10-length($val)) . $val; pack("H*",$val)',
+    },
+    0x23c => {
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+    },
+    # the 5DmkIII has "User setting1" and "User setting2" file naming options:
+    # - with "User setting1" 4 characters are selectable
+    # - with "User setting2", 3 characters are selectable, and the 4th character
+    # - in the file name corresponds to the image size:
+    #   L=large, M=medium, S=small1, T=small2, U=small3, _=movie
+    # - as shipped, the first 4 characters of the file name are unique to the camera
+    0x28c => { # used for file names like IMG_xxxx.JPG
+        Name => 'FileIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x290 => { # used for file names like 2F0Axxxx.JPG and 6T3Cxxxx.JPG
+        Name => 'FileIndex2',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x298 => { #(NC)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x29c => { #(NC)
+        Name => 'DirectoryIndex2',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x3b0 => {
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
+    },
+);
+
+# Camera information for 6D (MakerNotes tag 0x0d) (ref PH)
+%Image::ExifTool::Canon::CameraInfo6D = (
+    %binaryDataAttrs,
+    FORMAT => 'int8u',
+    FIRST_ENTRY => 0,
+    PRIORITY => 0,
+    IS_SUBDIR => [ 0x3c6 ],
+    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
+    NOTES => 'CameraInfo tags for the EOS 6D.',
+    0x03 => { %ciFNumber },
+    0x04 => { %ciExposureTime },
+    0x06 => { %ciISO },
+    0x1b => { %ciCameraTemperature },
+    0x23 => { %ciFocalLength },
+    0x83 => { # (5DmkIII + 6)
+        Name => 'CameraOrientation',
+        PrintConv => {
+            0 => 'Horizontal (normal)',
+            1 => 'Rotate 90 CW',
+            2 => 'Rotate 270 CW',
+        },
+    },
+    0x92 => { # (5DmkIII + 6)
+        Name => 'FocusDistanceUpper',
+        %focusDistanceByteSwap,
+    },
+    0x94 => { # (5DmkIII + 6)
+        Name => 'FocusDistanceLower',
+        %focusDistanceByteSwap,
+    },
+    0xc2 => { # (5DmkIII + 6)
+        Name => 'WhiteBalance',
+        Format => 'int16u',
+        SeparateTable => 1,
+        PrintConv => \%canonWhiteBalance,
+    },
+    0xc6 => { # (5DmkIII + 6)
+        Name => 'ColorTemperature',
+        Format => 'int16u',
+    },
+    0xfa => { # (5DmkIII + 6)
+        Name => 'PictureStyle',
+        Format => 'int8u',
+        Flags => ['PrintHex','SeparateTable'],
+        PrintConv => \%pictureStyles,
+    },
+    0x161 => { # (5DmkIII + 0x0e)
+        Name => 'LensType',
+        Format => 'int16uRev', # value is big-endian
+        SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
+        PrintConv => \%canonLensTypes,
+    },
+    0x163 => { %ciMinFocal }, # (5DmkIII + 0x0e)
+    0x165 => { %ciMaxFocal }, # (5DmkIII + 0x0e)
+    0x256 => { # (5DmkIII + 0x1a)
+        Name => 'FirmwareVersion',
+        Format => 'string[6]',
+        Writable => 0,
+    },
+    0x2aa => { # (5DmkIII + 0x16 or 0x1e)
+        Name => 'FileIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val + 1',
+        ValueConvInv => '$val - 1',
+    },
+    0x2b6 => { #(NC) (5DmkIII + 0x16 or 0x1e)
+        Name => 'DirectoryIndex',
+        Groups => { 2 => 'Image' },
+        Format => 'int32u',
+        ValueConv => '$val - 1',
+        ValueConvInv => '$val + 1',
+    },
+    0x3c6 => { # (5DmkIII + 0x16)
+        Name => 'PictureStyleInfo',
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo2' },
     },
 );
@@ -3244,8 +4148,26 @@
     FIRST_ENTRY => 0,
     PRIORITY => 0,
-    IS_SUBDIR => [ 0x20, 0x24 ],
-    DATAMEMBER => [ 0x1f ],
+    DATAMEMBER => [ 0x00, 0x1e ],
+    IS_SUBDIR => [ 0x327 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'CameraInfo tags for the EOS 7D.',
+    NOTES => q{
+        CameraInfo tags for the EOS 7D.  Indices shown are for firmware versions
+        1.0.x, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x1b2]',
+        RawConv => q{
+            my $t = substr($val, 0x1a8, 6); # 1 = firmware 3.7.5
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x1ac, 6);    # 2 = firmware 1.0.7/1.0.8/1.1.0/1.2.1/1.2.2
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $self->Warn('Unrecognized CameraInfo7D firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
     0x03 => { %ciFNumber },
     0x04 => { %ciExposureTime },
@@ -3253,5 +4175,5 @@
     0x07 => {
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x08 => { #37
@@ -3280,46 +4202,8 @@
     },
     0x19 => { %ciCameraTemperature },
-    0x1e => { %ciFocalLength },
-    0x1f => {
-        Name => 'FirmwareVersionLookAhead',
-        Hidden => 1,
-        # must look ahead to check location of FirmwareVersion string
-        Format => 'undef[0x1a0]',
-        RawConv => q{
-            my $t = substr($val, 0x1a8 - 0x1f, 6);
-            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirmA} = 1;
-            $t = substr($val, 0x1ac - 0x1f, 6);
-            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirmB} = 1;
-            return undef;   # not a real tag
-        },
-    },
-    0x20 => {
-        Name => 'CameraInfo7D_2a',
-        Condition => '$$self{CanonFirmA}',
-        Notes => 'at this location for pre-production firmware version 3.7.5',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CameraInfo7D_2',
-        },
-    },
-    0x24 => {
-        Name => 'CameraInfo7D_2b',
-        Condition => '$$self{CanonFirmB}',
-        Notes => 'at this location for firmware 1.0.7, 1.0.8, 1.1.0, 1.2.1 and 1.2.2',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::CameraInfo7D_2',
-        },
-    },
-);
-
-# variable-position Camera information for 7D (ref PH)
-%Image::ExifTool::Canon::CameraInfo7D_2 = (
-    %binaryDataAttrs,
-    FORMAT => 'int8u',
-    FIRST_ENTRY => 0,
-    PRIORITY => 0,
-    IS_SUBDIR => [ 0x303 ],
-    GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'More CameraInfo tags for the EOS 7D.',
-    0x11 => {
+    0x1e => { %ciFocalLength,
+        Hook => '$varSize += ($$self{CanonFirm} ? -4 : 0x10000) if $$self{CanonFirm} < 2',
+    },
+    0x35 => {
         Name => 'CameraOrientation',
         PrintConv => {
@@ -3329,13 +4213,13 @@
         },
     },
-    0x30 => {
+    0x54 => {
         Name => 'FocusDistanceUpper',
         %focusDistanceByteSwap,
     },
-    0x32 => {
+    0x56 => {
         Name => 'FocusDistanceLower',
         %focusDistanceByteSwap,
     },
-    0x53 => {
+    0x77 => {
         Name => 'WhiteBalance',
         Format => 'int16u',
@@ -3343,9 +4227,24 @@
         PrintConv => \%canonWhiteBalance,
     },
-    0x57 => {
+    0x7b => {
         Name => 'ColorTemperature',
         Format => 'int16u',
     },
-    0xa5 => {
+    0xaf => {
+        Name => 'CameraPictureStyle',
+        PrintHex => 1,
+        PrintConv => {
+            0x81 => 'Standard',
+            0x82 => 'Portrait',
+            0x83 => 'Landscape',
+            0x84 => 'Neutral',
+            0x85 => 'Faithful',
+            0x86 => 'Monochrome',
+            0x21 => 'User Defined 1',
+            0x22 => 'User Defined 2',
+            0x23 => 'User Defined 3',
+        },
+    },
+    0xc9 => {
         Name => 'HighISONoiseReduction',
         PrintConv => {
@@ -3356,13 +4255,14 @@
         },
     },
-    0xee => {
+    0x112 => {
         Name => 'LensType',
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xf0 => { %ciShortFocal },
-    0xf2 => { %ciLongFocal },
-    0x188 => {
+    0x114 => { %ciMinFocal },
+    0x116 => { %ciMaxFocal },
+    0x1ac => {
         Name => 'FirmwareVersion',
         Format => 'string[6]',
@@ -3371,5 +4271,5 @@
         RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $val : undef',
     },
-    0x1c7 => {
+    0x1eb => {
         Name => 'FileIndex',
         Groups => { 2 => 'Image' },
@@ -3378,5 +4278,5 @@
         ValueConvInv => '$val - 1',
     },
-    0x1d3 => { #(NC)
+    0x1f7 => { #(NC)
         Name => 'DirectoryIndex',
         Groups => { 2 => 'Image' },
@@ -3385,9 +4285,7 @@
         ValueConvInv => '$val + 1',
     },
-    0x303 => { #48
+    0x327 => { #48
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
 );
@@ -3450,8 +4348,9 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xd8 => { %ciShortFocal }, #15
-    0xda => { %ciLongFocal }, #15
+    0xd8 => { %ciMinFocal }, #15
+    0xda => { %ciMaxFocal }, #15
     0xff => { #15
         Name => 'FirmwareVersion',
@@ -3475,7 +4374,5 @@
     0x25b => {
         Name => 'PictureStyleInfo',
-        SubDirectory => {
-            TagTable => 'Image::ExifTool::Canon::PSInfo',
-        },
+        SubDirectory => { TagTable => 'Image::ExifTool::Canon::PSInfo' },
     },
     0x92b => { #33
@@ -3485,6 +4382,5 @@
 );
 
-# Canon camera information for 50D (MakerNotes tag 0x0d)
-# (ref PH unless otherwise noted)
+# Canon camera information for 50D (MakerNotes tag 0x0d) (ref PH)
 %Image::ExifTool::Canon::CameraInfo50D = (
     %binaryDataAttrs,
@@ -3492,8 +4388,26 @@
     FIRST_ENTRY => 0,
     PRIORITY => 0,
-    DATAMEMBER => [ 0x15a, 0x15e ],
-    IS_SUBDIR => [ 0x2d3, 0x2d7 ],
+    DATAMEMBER => [ 0x00, 0xee ],
+    IS_SUBDIR => [ 0x2d7 ],
     GROUPS => { 0 => 'MakerNotes', 2 => 'Camera' },
-    NOTES => 'CameraInfo tags for the EOS 50D.',
+    NOTES => q{
+        CameraInfo tags for the EOS 50D.  Indices shown are for firmware versions
+        1.0.x, but they may be different for other firmware versions.
+    },
+    0x00 => {
+        Name => 'FirmwareVersionLookAhead',
+        Hidden => 1,
+        # look ahead to check location of FirmwareVersion string
+        Format => 'undef[0x164]',
+        RawConv => q{
+            my $t = substr($val, 0x15a, 6); # 1 = firmware 2.6.1
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 1, return undef;
+            $t = substr($val, 0x15e, 6);    # 2 = firmware 2.9.1/3.1.1/1.0.2/1.0.3
+            $t =~ /^\d+\.\d+\.\d+/ and $$self{CanonFirm} = 2, return undef;
+            $self->Warn('Unrecognized CameraInfo50D firmware version');
+            $$self{CanonFirm} = 0;
+            return undef;   # not a real tag
+        },
+    },
     0x03 => { %ciFNumber },
     0x04 => { %ciExposureTime },
@@ -3501,5 +4415,5 @@
     0x07 => {
         Name => 'HighlightTonePriority',
-        PrintConv => { 0 => 'Off', 1 => 'On' },
+        PrintConv => \%offOn,
     },
     0x15 => { #PH (580 EX II)
@@ -3569,25 +4483,18 @@
         Format => 'int16uRev', # value is big-endian
         SeparateTable => 1,
+        ValueConvInv => 'int($val)', # (must truncate decimal part)
         PrintConv => \%canonLensTypes,
     },
-    0xec => { %ciShortFocal },
-    0xee => { %ciLongFocal },
-    0x15a => {
-        Name => 'FirmwareVersion',
-        Format => 'string[6]',
-        Notes => 'at this location for firmware 2.6.1',
-        Writable => 0,
-        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $$self{CanonFirmA}=$val : undef',
+    0xec => { %ciMinFocal },
+    0xee => { %ciMaxFocal,
+        Hook => '$varSize += ($$self{CanonFirm} ? -4 : 0x10000) if $$self{CanonFirm} < 2',
     },
     0x15e => { #33
         Name => 'FirmwareVersion',
         Format => 'string[6]',
-        Notes => 'at this location for firmware 1.0.2, 1.0.3, 2.9.1 and 3.1.1',
         Writable => 0,
-        RawConv => '$val=~/^\d+\.\d+\.\d+\s*$/ ? $$self{CanonFirmB}=$val : undef',
-    },
-    0x197 => {
+    },
+    0x19b => {
         Name => 'FileIndex',
-        Condition => '$$self{CanonFirmA}',
         Groups => { 2 => 'Image' },
         Format => 'int32u',
@@ -3595,15 +4502,6 @@
         ValueConvInv => '$val - 1',
     },
-    0x19b => {
-        Name => 'FileIndex',
-        Condition => '$$self{CanonFirmB}',
-        Groups => { 2 => 'Image' },
-        Format => 'int32u',
-        ValueConv => '$val + 1',
-        ValueConvInv => '$val - 1',
-    },
-    0x1a3 => { #(NC)
+    0x1a7 => { #(NC)
         Name => 'DirectoryIndex',
-        Condition => '$$self{CanonFirmA}',
         Groups => { 2 => 'Image' },
         Format => 'int32u',
